"""Users (principal) for the WAeUP portal.
"""
import grok
from waeup.authentication import Account
from waeup.interfaces import IUserContainer
from waeup.viewlets import LeftSidebar, MainArea, Index

class UserContainer(grok.Container):
    """A container for principals.

    See interfaces.py and users.txt for extensive description.
    """
    grok.implements(IUserContainer)
    grok.require('waeup.manageUsers')

    def addUser(self, name, password, title=None, description=None):
        if title is None:
            title = name
        if description is None:
            description = title
        self[name] = Account(name, password, title, description)

    def addAccount(self, account):
        self[account.name] = account
        
    def delUser(self, name):
        if name in self.keys():
            del self[name]

class UserContainerView(Index):
    grok.require('waeup.manageUsers')
    grok.context(IUserContainer)
    grok.name('index')
    def render(self, *args, **kw):
        return super(UserContainerView, self).render(*args, **kw)
    
class UserContainerMain(grok.Viewlet):
    grok.require('waeup.manageUsers')
    grok.viewletmanager(MainArea)
    grok.template('usermain')


